
ALTER DATABASE [UTILITY] SET ENABLE_BROKER;
GO
ALTER DATABASE [UTILITY] SET TRUSTWORTHY ON;
GO

USE [UTILITY];
GO
CREATE MESSAGE TYPE
       [//UTILITY/RequestMessage]
       VALIDATION = WELL_FORMED_XML;
CREATE MESSAGE TYPE
       [//UTILITY/ReplyMessage]
       VALIDATION = WELL_FORMED_XML;
GO

USE [UTILITY];
GO
CREATE CONTRACT [//UTILITY/Contract]
      ([//UTILITY/RequestMessage]
       SENT BY INITIATOR,
       [//UTILITY/ReplyMessage]
       SENT BY TARGET
      );
GO

USE UTILITY;
GO
CREATE QUEUE UpdStats_TargetQueue;

CREATE SERVICE [//UTILITY/UpdStats/TargetService]
	ON QUEUE UpdStats_TargetQueue ([//UTILITY/Contract]);
GO

USE UTILITY;
GO
CREATE QUEUE UpdStats_InitiatorQueue;

CREATE SERVICE [//UTILITY/UpdStats/InitiatorService]
	ON QUEUE UpdStats_InitiatorQueue;
GO

USE UTILITY;
GO
ALTER QUEUE UpdStats_TargetQueue
    WITH ACTIVATION
    ( STATUS = ON,
      PROCEDURE_NAME = UpdStats_internalActivationTarget,
      MAX_QUEUE_READERS = 3,
      EXECUTE AS SELF
    );
GO
ALTER QUEUE UpdStats_InitiatorQueue
    WITH ACTIVATION
    ( STATUS = ON,
      PROCEDURE_NAME = UpdStats_internalActivationInitiator,
      MAX_QUEUE_READERS = 3,
      EXECUTE AS SELF
    );
GO
